const Clutter = imports.gi.Clutter;
const Lang = imports.lang;
const Main = imports.ui.main;
const Mainloop = imports.mainloop;
const Params = imports.misc.params;
const PopupMenu = imports.ui.popupMenu;
const Meta = imports.gi.Meta;
const Gio = imports.gi.Gio;//[TDP]修改pin/unpin
const Util = imports.misc.util;
const St = imports.gi.St;
const Tweener = imports.ui.tweener;
const Gettext = imports.gettext;

const AppletDir = imports.ui.appletManager.applets['window-list@cdos.org'];
const MainApplet = AppletDir.applet;
const SpecialButtons = AppletDir.specialButtons;

const MessageTray = imports.ui.messageTray;

const THUMBNAIL_ICON_SIZE = 20;
const OPACITY_OPAQUE = 255;

const FavType = {
    favorites: 0,
    pinnedApps: 1,
    none: 2
}


function _(str) {
    let resultConf = Gettext.dgettext('window-list@cdos.org', str);
    if(resultConf != str) {
        return resultConf;
    }
    return Gettext.gettext(str);
}

/* [LT] notification */
function MMessageTraySource() {
    this._init();
}

MMessageTraySource.prototype = {
    __proto__: MessageTray.Source.prototype,
    _init: function() {
        MessageTray.Source.prototype._init.call(this, _("window list"));
        let icon = null;
        if(icon) this.setSummaryIcon(icon);
    }
};

// 右键菜单
function AppMenuButtonRightClickMenu() {
    this._init.apply(this, arguments);
}

AppMenuButtonRightClickMenu.prototype = {
    __proto__: PopupMenu.PopupMenu.prototype,

    _init: function (parent, actor) {
        //take care of menu initialization        
        PopupMenu.PopupMenu.prototype._init.call(this, parent.actor, 0.0, parent.orientation, 0);
        Main.uiGroup.add_actor(this.actor);
        //Main.chrome.addActor(this.actor, { visibleInOverview: true,
        //                                   affectsStruts: false });
        this.actor.hide();
        this.metaWindow = parent.metaWindow;

        this._parentActor = actor;
        this._parentActor.connect('button-release-event', Lang.bind(this, this._onParentActorButtonRelease));

        actor.connect('key-press-event', Lang.bind(this, this._onSourceKeyPress));
        this.connect('open-state-changed', Lang.bind(this, this._onToggled));

        this.orientation = parent.orientation;
        this.app = parent.app;
        this.isFavapp = parent.isFavapp;
        this._applet = parent._applet;
        //let PinnedFavorites = this._applet.pinned_app_contr();//[TDP]修改pin/unpin

        this.itemCloseWindow = new PopupMenu.PopupMenuItem(_("Close"));
        this.itemCloseWindow.connect('activate', Lang.bind(this, this._onCloseWindowActivate));

        // LT
        this.windows = [];

        this.itemCloseAllWindows = new PopupMenu.PopupMenuItem(_("Close all"));
        this.itemCloseAllWindows.connect('activate', Lang.bind(this, this._onCloseAllWindowsActivate));

        this.itemMinimizeWindow = new PopupMenu.PopupMenuItem(_("Minimize"));
        this.itemMinimizeWindow.connect('activate', Lang.bind(this, this._onMinimizeWindowActivate));

        this.itemMaximizeWindow = new PopupMenu.PopupMenuItem(_("Maximize"));
        this.itemMaximizeWindow.connect('activate', Lang.bind(this, this._onMaximizeWindowActivate));

        this.itemMoveToLeftWorkspace = new PopupMenu.PopupMenuItem(_("Move to left workspace"));
        this.itemMoveToLeftWorkspace.connect('activate', Lang.bind(this, this._onMoveToLeftWorkspace));

        this.itemMoveToRightWorkspace = new PopupMenu.PopupMenuItem(_("Move to right workspace"));
        this.itemMoveToRightWorkspace.connect('activate', Lang.bind(this, this._onMoveToRightWorkspace));

        this.itemOnAllWorkspaces = new PopupMenu.PopupMenuItem(_("Visible on all workspaces"));
        this.itemOnAllWorkspaces.connect('activate', Lang.bind(this, this._toggleOnAllWorkspaces));

        this.launchItem = new PopupMenu.PopupMenuItem(_("New Window"));
        this.launchItem.connect('activate', Lang.bind(this, this._launchMenu));
        // Settings in pinned apps menu;
        //this.settingItem = new PopupMenu.PopupMenuItem(_("Go to Settings"));
        //this.settingItem.connect('activate', Lang.bind(this, this._settingMenu));

        this.reArrange = new PopupMenu.PopupSwitchMenuItem(_("ReArrange"), this._applet.arrangePinned);
        this.reArrange.connect('toggled', Lang.bind(this, function(item) { this._applet.arrangePinned = item.state; }));

        this.showPinned = new PopupMenu.PopupSwitchMenuItem(_("Show Pinned"), this._applet.showPinned);
        this.showPinned.connect('toggled', Lang.bind(this, function(item) { this._applet.showPinned = item.state; }));

        //this.groupApps = new PopupMenu.PopupSwitchMenuItem(_("Group Apps"), this._applet.groupApps);
        //this.groupApps.connect('toggled', Lang.bind(this, function(item) { this._applet.groupApps = item.state; }));

        this.showThumbs = new PopupMenu.PopupSwitchMenuItem(_("Show Thumbs"), this._applet.showThumbs);
        this.showThumbs.connect('toggled', Lang.bind(this, function(item) { this._applet.showThumbs = item.state; }));

        this.verticalThumbs = new PopupMenu.PopupSwitchMenuItem(_("Vertical Thumbs"), this._applet.verticalThumbs);
        this.verticalThumbs.connect('toggled', Lang.bind(this, function(item) { this._applet.verticalThumbs = item.state; }));

        this.stackThumbs =  new PopupMenu.PopupSwitchMenuItem(_("Stack Thumbs"), this._applet.stackThumbs);
        this.stackThumbs.connect('toggled', Lang.bind(this, function(item) { this._applet.stackThumbs = item.state; }));

        this.enablePeek = new PopupMenu.PopupSwitchMenuItem(_("Hover to Peek"), this._applet.enablePeek);
        this.enablePeek.connect('toggled', Lang.bind(this, function(item) { this._applet.enablePeek = item.state; }));
        this.setVerticalSeparator(this);

        /* [TDP]修改pin/unpin: 判断应用是否已经添加到任务栏 */
        //this.favs = PinnedFavorites, this.favId = this.app.get_id(), this.isFav = this.favs.isFavorite(this.favId);//TDP
        this.appId = this.app.get_id();
        this.isAdded = this._isAddedToPanel(this.appId);

        if (this._applet.showPinned != FavType.none) {
            if (this.isAdded) { //[TDP]修改pin/unpin: this.isFav->this.isAdded
                this.itemtoggleFav = new PopupMenu.PopupMenuItem(_("Remove App"));//[TDP]修改pin/unpin: "Unpin App"->"Remove App"
                this.itemtoggleFav.connect('activate', Lang.bind(this, this._toggleFav));
            } else {
                this.itemtoggleFav = new PopupMenu.PopupMenuItem(_("Add App"));//[TDP]修改pin/unpin: "Pin App"->"Add App"
                this.itemtoggleFav.connect('activate', Lang.bind(this, this._toggleFav));
            }
        }
        if (this.isFavapp) this._isFavorite(true);
        else this._isFavorite(false);
    },
    /* [LT] */
    _ensureSource: function() {
        if (!this._source) {
            this._source = new MMessageTraySource();
            this._source.connect('destroy', Lang.bind(this, function() {
                this._source = null;
            }));
            if (Main.messageTray) Main.messageTray.add(this._source);
        }
    },

    _notify: function(iconName, title, text) {
        if(this._notification)
            this._notification.destroy();
        this._ensureSource();
        let icon = new St.Icon({ icon_name: iconName,
            icon_type: St.IconType.SYMBOLIC,
            icon_size: this._source.ICON_SIZE
        });
        this._notification = new MessageTray.Notification(this._source, title, text, { icon: icon});
        this._notification.setUrgency(MessageTray.Urgency.HIGH);
        this._notification.setTransient(true);
        this._notification.connect('destroy', function() {
            this._notification = null;
        });
        this._source.notify(this._notification);
    },
    /* [TDP]修改pin/unpin: 判断应用是否已经添加到任务栏API */
    _isAddedToPanel: function(appId) {
        let settings = new Gio.Settings({ schema: 'org.cdos' });
        let desktopFiles = settings.get_strv('panel-launchers');
        return desktopFiles.indexOf(appId) != -1;
        /*
        for (let i = 0; i < desktopFiles.length; i++) {
            if (appId == desktopFiles[i]) {
                return true;
            }
        }
        return false;
        */
    },

    _isFavorite: function (isAdded) {//[TDP]修改pin/unpin: isFav->isAdded
        //let showFavs = this._applet.showPinned;
        if (isAdded) {//[TDP]修改pin/unpin: isFav->isAdded
            //this.addMenuItem(this.settingItem);
            this.addMenuItem(this.reArrange);
            //this.addMenuItem(this.showPinned);
            //this.addMenuItem(this.groupApps);
            this.addMenuItem(this.showThumbs);
            this.addMenuItem(this.stackThumbs);
            this.addMenuItem(this.enablePeek);
            this.addMenuItem(this.verticalThumbs);
            this.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
            this.addMenuItem(this.launchItem);
            this.addMenuItem(this.itemtoggleFav);
        } else if (this.orientation == St.Side.BOTTOM) {
            //this.addMenuItem(this.itemOnAllWorkspaces);
            //this.addMenuItem(this.itemMoveToLeftWorkspace);
            //this.addMenuItem(this.itemMoveToRightWorkspace);
            //this.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
            this.addMenuItem(this.launchItem);
            //if (showFavs)
            this.addMenuItem(this.itemtoggleFav);
            //else this.addMenuItem(this.settingItem);
            this.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
            this.addMenuItem(this.itemMinimizeWindow);
            this.addMenuItem(this.itemMaximizeWindow);
            this.addMenuItem(this.itemCloseWindow);
            //this._refresh();
            this.addMenuItem(this.itemCloseAllWindows);
        } else {
            //this._refresh();
            this.addMenuItem(this.itemCloseAllWindows);
            this.addMenuItem(this.itemCloseWindow);
            this.addMenuItem(this.itemMaximizeWindow);
            this.addMenuItem(this.itemMinimizeWindow);
            this.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
            //if (showFavs)
                this.addMenuItem(this.itemtoggleFav);
            //else this.addMenuItem(this.settingItem);
            this.addMenuItem(this.launchItem);
            //this.addMenuItem(new PopupMenu.PopupSeparatorMenuItem());
            //this.addMenuItem(this.itemMoveToLeftWorkspace);
            //this.addMenuItem(this.itemMoveToRightWorkspace);
            //this.addMenuItem(this.itemOnAllWorkspaces);
        }
    },

    _onParentActorButtonRelease: function (actor, event) {

        if (event.get_state() & Clutter.ModifierType.BUTTON1_MASK) {
            if (this.isOpen) {
                this.toggle();
            }
        } else if (event.get_state() & Clutter.ModifierType.BUTTON2_MASK) {
            this.close(false);
        } else if (event.get_state() & Clutter.ModifierType.BUTTON3_MASK && !global.settings.get_boolean("panel-edit-mode")) {
            this.mouseEvent = event;
            this.toggle();
        }
    },

    _onToggled: function (actor, event) {
        if (!event || !this.metaWindow) return;

        if (this.metaWindow.is_on_all_workspaces()) {
            this.itemOnAllWorkspaces.label.text = _("Only on this workspace");
            this.itemMoveToLeftWorkspace.actor.hide();
            this.itemMoveToRightWorkspace.actor.hide();
        } else {
            this.itemOnAllWorkspaces.label.text = _("Visible on all workspaces");
            if (this.metaWindow.get_workspace().get_neighbor(Meta.MotionDirection.LEFT) != this.metaWindow.get_workspace()) this.itemMoveToLeftWorkspace.actor.show();
            else this.itemMoveToLeftWorkspace.actor.hide();

            if (this.metaWindow.get_workspace().get_neighbor(Meta.MotionDirection.RIGHT) != this.metaWindow.get_workspace()) this.itemMoveToRightWorkspace.actor.show();
            else this.itemMoveToRightWorkspace.actor.hide();
        }
        if (this.metaWindow.get_maximized()) {
            this.itemMaximizeWindow.label.text = _("Unmaximize");
        } else {
            this.itemMaximizeWindow.label.text = _("Maximize");
        }
        if (this.metaWindow.minimized) this.itemMinimizeWindow.label.text = _("Restore");
        else this.itemMinimizeWindow.label.text = _("Minimize");
    },

    _onWindowMinimized: function (actor, event) {},

    _onCloseWindowActivate: function (actor, event) {
        this.metaWindow.delete(global.get_current_time());
        //this.destroy();
    },

    _onCloseAllWindowsActivate: function (actor, event) {
        /*
           let wks = this.metaWindow.get_workspace();
           let windows = this.app.get_windows().filter(function (win) {
           return win.get_workspace() == wks;
           });
           */
        this.windows.forEach(function (window) {
            window.delete(global.get_current_time());
        });
    },
    _onMinimizeWindowActivate: function (actor, event) {
        if (this.metaWindow.minimized) {
            this.metaWindow.unminimize(global.get_current_time());
            this.metaWindow.activate(global.get_current_time());
        } else {
            this.metaWindow.minimize(global.get_current_time());
        }
    },

    _onMaximizeWindowActivate: function (actor, event) {
        if (this.metaWindow.get_maximized()) {
            this.metaWindow.unmaximize(Meta.MaximizeFlags.HORIZONTAL | Meta.MaximizeFlags.VERTICAL);
        } else {
            this.metaWindow.maximize(Meta.MaximizeFlags.HORIZONTAL | Meta.MaximizeFlags.VERTICAL);
        }
    },

    _onMoveToLeftWorkspace: function (actor, event) {
        let workspace = this.metaWindow.get_workspace().get_neighbor(Meta.MotionDirection.LEFT);
        if (workspace) {
            //this.actor.destroy();
            this.metaWindow.change_workspace(workspace);
            Main._checkWorkspaces();
        }
    },

    _onMoveToRightWorkspace: function (actor, event) {
        let workspace = this.metaWindow.get_workspace().get_neighbor(Meta.MotionDirection.RIGHT);
        if (workspace) {
            //this.actor.destroy();
            this.metaWindow.change_workspace(workspace);
            Main._checkWorkspaces();
        }
    },

    _toggleOnAllWorkspaces: function (actor, event) {
        if (this.metaWindow.is_on_all_workspaces()) this.metaWindow.unstick();
        else this.metaWindow.stick();
    },

    _toggleFav: function (actor, event) {
        /* [TDP]修改pin/unpin */

        //获取任务栏快捷应用列表
        let settings = new Gio.Settings({ schema: 'org.cdos' });
        let desktopFiles = settings.get_strv('panel-launchers');

        //如果已经添加，则从列表中删除；如果未添加，则添加到任务栏
        if (this.isAdded) {
            this.close(false);
            //this.favs.removeFavorite(this.favId)//TDP
            //desktopFiles.pop(this.appId);
            for(let i = 0; i < desktopFiles.length; i++)
            {
                if (desktopFiles[i] === this.appId) {
                    desktopFiles.splice(i, 1);
                }
            }
            settings.set_strv('panel-launchers', desktopFiles);
            this.itemtoggleFav.label.text = _("Add App");
        } else {
            this.close(false);
            //this.favs.addFavorite(this.favId);//TDP
            if (desktopFiles.length >= 8) {
                this._notify('', _('window list'), _('too many favorite applications, please delete some first'));
                return;
            }
            desktopFiles.push(this.appId);
            settings.set_strv('panel-launchers', desktopFiles);
            this.itemtoggleFav.label.text = _("Remove App");
        }
    },

    _launchMenu: function () {
        this.app.open_new_window(-1);
    },

    _settingMenu: function () {
        Util.spawnCommandLine("cdos-settings applets window-list@cdos.org");
    },

    removeItems: function () {
        let children = this._getMenuItems();
        for (let i = 0; i < children.length; i++) {
            let item = children[i];
            this.box.remove_actor(item.actor);
        }
    },

    destroy: function () {
        let children = this._getMenuItems();
        for (let i = 0; i < children.length; i++) {
            let item = children[i];
            this.box.remove_actor(item.actor);
            item.actor.destroy();
        }
        this.box.destroy();
        this.actor.destroy();
    },

    _onSourceKeyPress: function (actor, event) {
        let symbol = event.get_key_symbol();
        if (symbol == Clutter.KEY_space || symbol == Clutter.KEY_Return) {
            this.menu.toggle();
            return true;
        } else if (symbol == Clutter.KEY_Escape && this.menu.isOpen) {
            this.menu.close();
            return true;
        } else if (symbol == Clutter.KEY_Down) {
            if (!this.menu.isOpen) this.menu.toggle();
            this.menu.actor.navigate_focus(this.actor, Gtk.DirectionType.DOWN, false);
            return true;
        } else return false;
    },
    _refresh: function() {
        let wks = this.metaWindow.get_workspace();
        this.windows = this.app.get_windows().filter(function (win) {
            return win.get_workspace() == wks;
        });
        if(this.windows.length <= 1)
            this.itemCloseAllWindows.actor.hide();
        else
            this.itemCloseAllWindows.actor.show();
    },
    setMetaWindow: function (metaWindow) {
        //this.windows.push(metaWindow);
        this.metaWindow = metaWindow;
        this._refresh();
    }
};

function HoverMenuController(owner) {
    this._init(owner);
}

HoverMenuController.prototype = {
    __proto__: PopupMenu.PopupMenuManager.prototype,

    _onEventCapture: function (actor, event) {
        return false;
    }
};

function AppThumbnailHoverMenu() {
    this._init.apply(this, arguments);
}

AppThumbnailHoverMenu.prototype = {
    __proto__: PopupMenu.PopupMenu.prototype,

    _init: function (parent) {
        PopupMenu.PopupMenu.prototype._init.call(this, parent.actor, 0.45, parent.orientation);
        this._applet = parent._applet;
        this.metaWindow = parent.metaWindow;
        this.app = parent.app;
        this.isFavapp = parent.isFavapp;
        //need to impliment this class or cdos outputs a bunch of errors
        this.actor.style_class = "hide-arrow";
        this.actor.hide();
        this.box.set_style("background:none; border:none;");
        this.parentActor = parent.actor;

        Main.layoutManager.addChrome(this.actor, this.orientation);

        this.appSwitcherItem = new PopupMenuAppSwitcherItem(this);
        this.addMenuItem(this.appSwitcherItem);

        this.parentActor.connect('enter-event', Lang.bind(this, this._onEnter));
        this.parentActor.connect('leave-event', Lang.bind(this, this._onLeave));
        this.parentActor.connect('button-release-event', Lang.bind(this, this._onButtonPress));

        this.actor.connect('enter-event', Lang.bind(this, this._onMenuEnter));
        this.actor.connect('leave-event', Lang.bind(this, this._onMenuLeave));

        this.actor.connect('button-release-event', Lang.bind(this, this._onButtonPress));
        this._applet.settings.connect('thumbnail-timeout', Lang.bind(this, function () { this.hoverTime =  this._applet.settings.getValue("thumbnail-timeout")}));
        this.hoverTime =  this._applet.settings.getValue("thumbnail-timeout");
    },

    _onButtonPress: function (actor, event) {
        if(this.parentActor == actor && this._applet.onclickThumbs) return;
        this.shouldOpen = false;
        this.shouldClose = true;
        Mainloop.timeout_add(this.hoverTime, Lang.bind(this, this.hoverClose));
    },

    _onMenuEnter: function () {
        this.shouldOpen = true;
        this.shouldClose = false;

        Mainloop.timeout_add(this.hoverTime, Lang.bind(this, this.hoverOpen));
    },

    _onMenuLeave: function () {
        this.shouldOpen = false;
        this.shouldClose = true;
        Mainloop.timeout_add(this.hoverTime, Lang.bind(this, this.hoverClose));
    },

    _onEnter: function () {
        // lt: 没有metawindow，显示tooltips
        if(!this.metaWindow)
            return;
        this.shouldOpen = true;
        this.shouldClose = false;

        Mainloop.timeout_add(this.hoverTime, Lang.bind(this, this.hoverOpen));
    },

    _onLeave: function () {
        this.shouldClose = true;
        this.shouldOpen = false;

        Mainloop.timeout_add(this.hoverTime, Lang.bind(this, this.hoverClose));
    },

    hoverOpen: function () {
        if (this.shouldOpen && !this.isOpen) {
            this.open(true);
        }
    },

    hoverClose: function () {
        if (this.shouldClose) {
            this.close(true);
        }
    },

    open: function (animate) {
        // Refresh all the thumbnails, etc when the menu opens.  These cannot
        // be created when the menu is initalized because a lot of the clutter window surfaces
        // have not been created yet...
        this.appSwitcherItem._refresh();
        this.appSwitcherItem.actor.show();
        PopupMenu.PopupMenu.prototype.open.call(this, animate);
    },

    close: function (animate) {
        // Refresh all the thumbnails, etc when the menu opens.  These cannot
        // be created when the menu is initalized because a lot of the clutter window surfaces
        // have not been created yet...
        PopupMenu.PopupMenu.prototype.close.call(this, animate);
        this.appSwitcherItem.actor.hide();
    },

    destroy: function () {
        let children = this._getMenuItems();
        for (let i = 0; i < children.length; i++) {
            let item = children[i];
            this.box.remove_actor(item.actor);
            item.actor.destroy();
        }
        this.box.destroy();
        this.actor.destroy();
    },


    setMetaWindow: function (metaWindow) {
        this.metaWindow = metaWindow;
        this.appSwitcherItem.setMetaWindow(metaWindow);
    }
};

// display a list of app thumbnails and allow
// bringing any app to focus by clicking on its thumbnail

function PopupMenuAppSwitcherItem() {
    this._init.apply(this, arguments);
}

PopupMenuAppSwitcherItem.prototype = {
    __proto__: PopupMenu.PopupBaseMenuItem.prototype,

    _init: function (parent, params) {
        params = Params.parse(params, {
            hover: false
        });
        PopupMenu.PopupBaseMenuItem.prototype._init.call(this, params);

        this._applet = parent._applet;
        this.metaWindow = parent.metaWindow;
        this.app = parent.app;
        this.isFavapp = parent.isFavapp;
        this._parentContainer = parent;

        this.actor.style_class = null;

        this.box = new St.BoxLayout({
            vertical: true,
        });

        this.showThumbs = this._applet.showThumbs;
        this._maxVerticalThumbs = 10;
        this.appContainer = new St.BoxLayout({
            style_class: 'switcher-list',
            /*vertical: true,*/
        });
        this.appContainer.style = "margin: 0px;padding: 12px;";
        this.appContainer2 = new St.BoxLayout({
            style_class: 'switcher-list',
        });
        this.appContainer2.style = "margin: 0px;padding: 12px;";
        this.appContainer2.hide();
        this.appContainer3 = new St.BoxLayout({
            style_class: 'switcher-list',
        });
        this.appContainer3.style = "margin: 0px;padding: 12px;";
        this.appContainer3.hide();

        this.appContainer4 = new St.BoxLayout({
            style_class: 'switcher-list',
            vertical: true,
        });
        this.appContainer4.style = "margin: 0px;padding: 10px;";
        this.box.add_actor(this.appContainer4);
        this.appContainer4.hide();
        this.button_prev = new St.BoxLayout({
            style_class: 'window-prev',
            height: 20,
            vertical: true,
            reactive: true
        });
        this.button_next = new St.BoxLayout({
            style_class: 'window-next',
            height: 20,
            vertical: true,
            reactive: true
        });
        this.appBox4 = new St.BoxLayout({
            style_class: 'switcher-list-box',
            vertical: true,
        });
        this.appBox4.hide();
        this.appContainer4.add_actor(this.button_prev);
        this.appContainer4.add_actor(this.appBox4);
        this.appContainer4.add_actor(this.button_next);

        let button1 = new St.Bin({
            style_class: 'button-prev'
        });

        let button2 =  new St.Bin({
            style_class: 'button-next'
        });
        this.button_prev.add(button1, {
            x_fill: true,
            x_align: St.Align.MIDDLE
        });
        this.button_next.add(button2, {
            x_fill: false,
            y_fill: false,
            x_align: St.Align.MIDDLE,
            y_align: St.Align.END,
        });

        //this.appContainer4.add_actor(this.button_prev);
        //this.appContainer4.add_actor(this.appBox4);
        //this.appContainer4.add_actor(this.button_next);
        
        this._appBox4Index = 0;
        //this.button_prev.raise_top();
        //this.button_next.raise_top();
        this.button_prev.hide();
        this.appBox4.hide();
        this.button_next.hide();
        this.appContainer4IsShowing = false;

        this.appThumbnails = {};
        this.appThumbnails2 = {};
        this.appThumbnails3 = {};

        this._applet.settings.connect("changed::vertical-thumbnails", Lang.bind(this, this._setVerticalSetting));
        this._setVerticalSetting();
        this.addActor(this.box);

        this._refresh();

        this.button_prev.connect('button-release-event', Lang.bind(this, this._onButtonPrevRelease));
        this.button_next.connect('button-release-event', Lang.bind(this, this._onButtonNextRelease));
    },

    _onButtonPrevRelease: function() {
        //this.appBox4.set_translation(0, 30, 0);
        let windows = this.app.get_windows().filter(Lang.bind(this, function (win) {
            return (win.get_workspace() == this.metaWindow.get_workspace());
        })).reverse();
        /* 删除最前面的，尾部添加 */
        this._appBox4Index += 1;
        let actors = this.appBox4.get_children();
        //log('button_prev => actorLength: '+actors.length + ' ;appIndex: '+this._appBox4Index);
        if(this._appBox4Index + actors.length > windows.length) {
            this._appBox4Index -= 1;
            return true;
        }
        
        let actor = actors[0];
        this.appBox4.remove_actor(actor);

        let metaWindow = windows[this._appBox4Index + actors.length - 1];
        /*
        log('windows length : ' + windows.length);
        log('appIndex: ' + this._appBox4Index);
        log(this._appBox4Index + actors.length - 1);
        */
        let thumbnail = null;
        if (!this.appThumbnails[metaWindow]){
            thumbnail = new WindowThumbnail(this, metaWindow);
            this.appThumbnails[metaWindow] = {
                metaWindow: metaWindow,
                thumbnail: thumbnail,
                cont: 4
            };
        }else
            thumbnail = this.appThumbnails[metaWindow].thumbnail;
        this.appBox4.add_actor(thumbnail.actor);
        return true;
    },

    _onButtonNextRelease: function() {
        //this.appBox4.set_translation(0, -30, 0);
        let windows = this.app.get_windows().filter(Lang.bind(this, function (win) {
            return (win.get_workspace() == this.metaWindow.get_workspace());
        })).reverse();
        /* 删除最后一个 */
        this._appBox4Index -= 1;
        let actors = this.appBox4.get_children();
        //log('button_prev => actorLength: '+actors.length + ' ;appIndex: '+this._appBox4Index);        
        if(this._appBox4Index < 0)
        {
            this._appBox4Index = 0;
            return true;
        }
        let actor = actors[actors.length - 1];
        this.appBox4.remove_actor(actor);
        let metaWindow = windows[this._appBox4Index];
        let thumbnail = null;
        if (!this.appThumbnails[metaWindow]){
            thumbnail = new WindowThumbnail(this, metaWindow);
            this.appThumbnails[metaWindow] = {
                metaWindow: metaWindow,
                thumbnail: thumbnail,
                cont: 4
            };
        }else {
            thumbnail = this.appThumbnails[metaWindow].thumbnail;
        }
        this.appBox4.add_actor(thumbnail.actor);
        this.appBox4.lower_child(thumbnail.actor, this.appBox4.get_children()[0]);
        return true;
    },

    _setVerticalSetting: function() {
        let vertical = this._applet.settings.getValue("vertical-thumbnails");
        if(vertical){
            if(this.box.get_children() > 0) {
                //this.box.remove_actor(this.appContainer4);
                this.box.remove_actor(this.appContainer3);
                this.box.remove_actor(this.appContainer2);
                this.box.remove_actor(this.appContainer);
                this.box.add_actor(this.appContainer);
                this.box.add_actor(this.appContainer2);
                this.box.add_actor(this.appContainer3);
            }else{
                this.box.add_actor(this.appContainer);
                this.box.add_actor(this.appContainer2);
                this.box.add_actor(this.appContainer3);
            }    
        }else{
            if(this.box.get_children() > 0) {
                //this.box.remove_actor(this.appContainer4);
                this.box.remove_actor(this.appContainer3);
                this.box.remove_actor(this.appContainer2);
                this.box.remove_actor(this.appContainer);
                this.box.add_actor(this.appContainer3);
                this.box.add_actor(this.appContainer2);
                this.box.add_actor(this.appContainer);
            }else{
                this.box.add_actor(this.appContainer3);
                this.box.add_actor(this.appContainer2);
                this.box.add_actor(this.appContainer);
            }
        }
        //this.box.add_actor(this.appContainer4);
        this.appContainer.vertical  = vertical;
        this.appContainer2.vertical = vertical;
        this.appContainer3.vertical = vertical;
        this.box.vertical = !vertical;
    },

    setMetaWindow: function (metaWindow) {
        this.metaWindow = metaWindow;
    },

    _isFavorite: function (isAdded) {//[TDP]修改pin/unpin: isFav->isAdded
        this.isFavapp = isAdded;
        //if (isAdded) this.isFavapp = true;
        //else this.isFavapp = false;
    },

    _refresh: function () {
        // Check to see if this.metaWindow has changed.  If so, we need to recreate
        // our thumbnail, etc.
        if(this.metaWindowThumbnail && !this.metaWindowThumbnail.needs_refresh())
            this.metaWindowThumbnail = null;
        if (this.metaWindowThumbnail && this.metaWindowThumbnail.metaWindow == this.metaWindow) {
            this.metaWindowThumbnail._isFavorite(this.isFavapp); /*  */
        } else {
            if (this.metaWindowThumbnail) {
                this.metaWindowThumbnail.destroy();
            }
            // If our metaWindow is null, just move along
            /* 不再用 */
            /*
            if (this.isFavapp) {
                this.metaWindowThumbnail = new WindowThumbnail(this, this.metaWindow);
                this.appContainer.insert_actor(this.metaWindowThumbnail.actor, 0);
            }
            */
        }

        // Get a list of all windows of our app that are running in the current workspace
        if(!this.metaWindow)
            return;
        let windows = this.app.get_windows().filter(Lang.bind(this, function (win) {
            /*
            let metaWorkspace = null;
            if (this.metaWindow) metaWorkspace = this.metaWindow.get_workspace();
            //let isDifferent = (win != this.metaWindow);
            let isSameWorkspace = (win.get_workspace() == metaWorkspace);
            return isSameWorkspace;
            */
            //if (this.metaWindow)
                return (win.get_workspace() == this.metaWindow.get_workspace());
        })).reverse();
        // Update appThumbnails to remove old programs
        let w = [];
        this.removeOldWindows(w);
        // Update appThumbnails to include new programs
        this.addNewWindows(windows);
    },
    addNewWindows: function (windows) {
        //let ThumbnailWidth = Math.floor((Main.layoutManager.primaryMonitor.width / 70) * this._applet.thumbSize) + 16;
        //let ThumbnailHeight = Math.floor((Main.layoutManager.primaryMonitor.height / 70) * this._applet.thumbSize) + 16;
        let ThumbnailWidth = 240;
        let ThumbnailHeight = 184;
        let moniterSize, thumbnailSize;
        if(this._applet.settings.getValue("vertical-thumbnails")){
            moniterSize = Main.layoutManager.primaryMonitor.height;
            thumbnailSize = ThumbnailHeight;
        }else{
            moniterSize = Main.layoutManager.primaryMonitor.width;
            thumbnailSize = ThumbnailWidth;
        }
        this.thumbnailsSpace = Math.floor((moniterSize - 100) / thumbnailSize);
        this._maxHorizontalThumbs = this.thumbnailsSpace;// * 3;
        if(windows.length > this._maxHorizontalThumbs) {
            //this._maxVerticalThumbs = Math.floor((Main.layoutManager.primaryMonitor.height
            //let w = [];
            //this.removeOldWindows(w);
            this.showThumbs = false;
            function max(a, b) {
                return a > b ? a : b;
            }
            this.addWindowsLoop(max(this._appBox4Index, 0),windows.length,this.appBox4,windows,4);

            this.appContainer.hide();
            this.appContainer2.hide();
            this.appContainer3.hide();
            this.appContainer4.show();
            this.appContainer4IsShowing = true;
            return;
        }
        if((windows.length <= this._maxHorizontalThumbs) && !this.showThumbs && this.appContainer4IsShowing) {
            this.showThumbs = true;
            this.appContainer4IsShowing = false;
            this.appContainer4.hide();
            let w = [];
            this.removeOldWindows(w);
        }
        if ((thumbnailSize * windows.length) + thumbnailSize >= moniterSize)
        {
            //this.thumbnailsSpace = Math.floor((moniterSize - 100) / thumbnailSize);
            
            let firstLoop = this.thumbnailsSpace;
            let nextLoop = firstLoop + this.thumbnailsSpace;
            //if(windows.length < firstLoop)
            //    firstLoop = windows.length;
            this.addWindowsLoop(0,firstLoop,this.appContainer,windows,1);
            if(windows.length > nextLoop){
                this.addWindowsLoop(firstLoop,nextLoop,this.appContainer2,windows,2);
                this.addWindowsLoop(nextLoop,windows.length,this.appContainer3,windows,3);
            }else if(windows.length > firstLoop)
                this.addWindowsLoop(firstLoop,windows.length,this.appContainer2,windows,2);
            //if(windows.length > nextLoop)
            //    this.addWindowsLoop(nextLoop,windows.length,this.appContainer3,windows,3);
        } else {
            this.addWindowsLoop(0,windows.length,this.appContainer,windows,1);
        }
    },

    addWindowsLoop: function(n, winLength, actor, windows,containerNum) {
        for(let i = n; i < winLength; i++) {
            let metaWindow = windows[i];

            if (this.appThumbnails[metaWindow] && (containerNum != 4)) {
                this.appThumbnails[metaWindow].thumbnail._isFavorite(this.isFavapp);
            } else {
                let thumbnail = this.appThumbnails[metaWindow];
                if (!thumbnail || !thumbnail.actor) {
                    thumbnail = new WindowThumbnail(this, metaWindow);
                    this.appThumbnails[metaWindow] = {
                        metaWindow: metaWindow,
                        thumbnail: thumbnail,
                        cont: containerNum
                    };
                }
                //if(containerNum != 4 || 
                //        (containerNum == 4 && (this.appBox4.get_children().indexOf(thumbnail.actor) == -1)))
                    actor.add_actor(thumbnail.actor);
                //thumbnail.actor.set_z_position(i);
                //thumbnail.actor.set_rotation(Clutter.RotateAxis.X_AXIS, i * 10, 0, 0, 0);
                //actor.add_actor(this.appThumbnails[metaWindow].thumbnail.actor);
            }
            if (this.appBox4.get_height() >=  Main.layoutManager.primaryMonitor.height - 150)
            {
                this.button_prev.set_height(20);
                this.button_prev.show();
                this.button_next.set_height(20);
                this.button_next.show();
                break;
            }
        }
        if((containerNum == 4) && (this.appBox4.get_height() <=  Main.layoutManager.primaryMonitor.height - 150)){
            this.button_prev.hide();
            this.button_next.hide();
            if(n != 0) {
                this._appBox4Index = 0;
                this._refresh();
            }
        }
        actor.show();
    },

    removeOldWindows: function(windows) {
        for (let win in this.appThumbnails) {
            if (windows.indexOf(this.appThumbnails[win].metaWindow) == -1) {
                if(this.appThumbnails[win].cont == 1){
                    this.appContainer.remove_actor(this.appThumbnails[win].thumbnail.actor);
                }else if(this.appThumbnails[win].cont == 2){
                    this.appContainer2.remove_actor(this.appThumbnails[win].thumbnail.actor);
                }else if(this.appThumbnails[win].cont == 3){
                    this.appContainer3.remove_actor(this.appThumbnails[win].thumbnail.actor);
                }else if(this.appThumbnails[win].cont == 4){
                    this.appBox4.remove_actor(this.appThumbnails[win].thumbnail.actor);
                }
                this.appThumbnails[win].thumbnail.destroy();
                delete this.appThumbnails[win];
            }
        }
        if(this.appContainer.get_children().length < this.thumbnailsSpace && this.appContainer2.get_children().length > 0){
            let actor = this.appContainer2.get_children()[0];
            this.appContainer2.remove_actor(actor);
            this.appContainer.add_actor(actor);
        }
        if(this.appContainer2.get_children().length <= 0)
            this.appContainer2.hide();
        if(this.appContainer2.get_children().length < this.thumbnailsSpace && this.appContainer3.get_children().length > 0){
            let actor = this.appContainer3.get_children()[0];
            this.appContainer3.remove_actor(actor);
            this.appContainer2.add_actor(actor);
        }
        if(this.appContainer3.get_children().length <= 0)
            this.appContainer3.hide();
        if(this.appBox4.get_children().length <= this._maxHorizontalThumbs)
            this.appContainer4.hide();
        /* 删除window，隐藏 appContainer4 button */
    }
};

function WindowThumbnail() {
    this._init.apply(this, arguments);
}

WindowThumbnail.prototype = {

    _init: function (parent, metaWindow) {
        this._applet = parent._applet;
        this.metaWindow = metaWindow || null;
        this.app = parent.app;
        this.isFavapp = parent.isFavapp || false;
        this.wasMinimized = false;
        this._parent = parent;

        this.actor = new St.BoxLayout({
            style_class: 'item-box',
            reactive: true,
            track_hover: true,
            vertical: true
        });
        this.thumbnailActor = new St.Bin();
        this.thumbnailActor.hide();

        this.container1 = new St.BoxLayout();
        this.icon = this.app.create_icon_texture(THUMBNAIL_ICON_SIZE);
        this.label = new St.Label();
        this.container1.add_actor(this.icon);
        this.container1.add_actor(this.label);

        this.container2 = new St.BoxLayout();

        this.button = new St.BoxLayout({
            style_class: 'window-close-cs',
            reactive: true
        });
        this.button.hide();

        this.container2.add_actor(this.container1);
        this.container2.add_actor(this.button);

        this.actor.add_actor(this.container2);
        if(this._parent.showThumbs) this.actor.add_actor(this.thumbnailActor);

        // LT 12/22 13.24 
        if (this.isFavapp) this._isFavorite(true);
        else this._isFavorite(false);

        if (this.metaWindow) this.metaWindow.connect('notify::title', Lang.bind(this, function () {
            this.label.text = this.metaWindow.get_title();
        }));

        this.actor.connect('enter-event', Lang.bind(this, function () {
            //if (!this.isFavapp)
            {
                this._hoverPeek(this._applet.peekOpacity, this.metaWindow);
                this.actor.add_style_pseudo_class('outlined');
                this.actor.add_style_pseudo_class('selected');
                // LT hover 时总显示 close-button
                //if(this._applet.showThumbs)//[TDP]修改缩略图: 关闭按钮在显示缩略图时常时显示
                this.button.show();
                if (this.metaWindow.minimized && this._applet.enablePeek) {
                    this.metaWindow.unminimize();
                    this.wasMinimized = true;
                } else this.wasMinimized = false;
            }
        }));
        this.actor.connect('leave-event', Lang.bind(this, function () {
            //if (!this.isFavapp)
            {
                this._hoverPeek(OPACITY_OPAQUE, this.metaWindow);
                this.actor.remove_style_pseudo_class('outlined');
                this.actor.remove_style_pseudo_class('selected');
                this.button.hide();
                if (this.wasMinimized) {
                    this.metaWindow.minimize(global.get_current_time());
                }
            }
        }));
        this.button.connect('button-release-event', Lang.bind(this, this._onButtonRelease));

        this.actor.connect('button-release-event', Lang.bind(this, this._connectToWindow));
    },

    _isFavorite: function (isAdded) {
        // Whether we create a favorite tooltip or a window thumbnail
        /* 用tooltips替代 */
        /*
        if (isAdded) {
            this.thumbnailActor.child = null;
            let apptext = this.app.get_name();
            // not sure why it's 7
            this.ThumbnailWidth = THUMBNAIL_ICON_SIZE + Math.floor(apptext.length * 7.0);
            this.label.style = "font-size: 12px; color: #fff;";
            this.label.text = apptext;
            this.isFavapp = true;
            this.actor.style = "border-width:1px;";
            this.container1.style = "width: " + this.ThumbnailWidth + "px";
        } else*/
        {
            this._refresh();
            this.actor.style = "border-width:1px; padding-bottom: 14px;";
        }
    },

    destroy: function () {
        this.actor.destroy();
    },

    needs_refresh: function () {
        return Boolean(this.thumbnail);
    },

    _getThumbnail: function () {
        // Create our own thumbnail if it doesn't exist
        let thumbnail = null;
        let muffinWindow = this.metaWindow.get_compositor_private();
        if (muffinWindow) {
            let windowTexture = muffinWindow.get_texture();
            let[width, height] = windowTexture.get_size();
            let scale = Math.min(1.0, this.ThumbnailWidth / width, this.ThumbnailHeight / height);
            thumbnail = new Clutter.Clone({
                source: windowTexture,
                      reactive: true,
                      width: width * scale,
                      height: height * scale
            });
        }

        return thumbnail;
    },

    _onButtonRelease: function (actor, event) {
        if (event.get_state() & Clutter.ModifierType.BUTTON1_MASK && actor == this.button) {
            this._hoverPeek(OPACITY_OPAQUE, this.metaWindow);
            this.metaWindow.delete(global.get_current_time());
            /*
            this._parentContainer.shouldOpen = true;
            this._parentContainer.shouldClose = false;
            this._parentContainer.hoverOpen();
            */
            this.stopClick = true;
        }
    },

    _connectToWindow: function (actor, event) {
        this.wasMinimized = false;
        if (event.get_state() & Clutter.ModifierType.BUTTON1_MASK && !this.stopClick && !this.isFavapp) {
            this.metaWindow.activate(global.get_current_time());
        }else if (event.get_state() & Clutter.ModifierType.BUTTON2_MASK && !this.stopClick) {
            this.metaWindow.delete(global.get_current_time());
        }
        this.stopClick = false;
    },

    _refresh: function () {
        // Turn favorite tooltip into a normal thumbnail
        //this.ThumbnailHeight = Math.floor(Main.layoutManager.primaryMonitor.height / 100) * this._applet.thumbSize;
        //this.ThumbnailWidth = Math.floor(Main.layoutManager.primaryMonitor.width / 100) * this._applet.thumbSize;

        this.ThumbnailHeight = 108;
        this.ThumbnailWidth = 200;
        //修改缩略图布局
        this.label.style = "font-size: 12px; color: #fff;";
        this.button.set_margin_left(10);
        this.container2.set_margin_top(12);
        this.container2.set_margin_left(8);
        this.container2.set_margin_right(8);

        if (this._parent.showThumbs) {
            this.thumbnailActor.style = "border: 1px solid rgba(102,102,102,1);";        
            this.thumbnailActor.set_margin_top(14);
            this.thumbnailActor.set_margin_left(8);
            this.thumbnailActor.set_margin_right(8);
        }
        this.actor.set_margin_left(1);
        this.actor.set_margin_right(1);

        this.container1.style = "width: " + Math.floor(this.ThumbnailWidth - 20) + "px";
        if(!this._parent.showThumbs)
            this.container2.set_width(Math.floor(this.ThumbnailWidth));
        else
            this.container2.set_width(-1);

        this.isFavapp = false;

        // Replace the old thumbnail
        let title = this.metaWindow.get_title();
        this.label.text = title;
        
        if (this._parent.showThumbs){
            this.thumbnail = this._getThumbnail();
            this.thumbnail.height = this.ThumbnailHeight;
            this.thumbnail.width = this.ThumbnailWidth;
            this.thumbnailActor.child = this.thumbnail;
            this.thumbnailActor.show();            
        } else {
            this.thumbnailActor.child = null;
        }
    },

    _hoverPeek: function (opacity, metaWin) {
        let applet = this._applet;
        if (applet.enablePeek == false) return;

        function setOpacity(window_actor, target_opacity) {
            Tweener.addTween(window_actor, {
                time: 0.5,  //[TDP]修改缩略图: applet.peekTime * 0.001->2
                transition: 'easeInOutExpo',//[TDP]修改缩略图: easeOutQuad->easeInExpo
                opacity: target_opacity,
            });
        }

        let above_current = new Array();

        global.get_window_actors().forEach(function (wa) {
            var meta_win = wa.get_meta_window();
            if (metaWin == meta_win) return;

            if (meta_win.get_window_type() != Meta.WindowType.DESKTOP)
                setOpacity(wa, opacity);
        });
    }
};

